#!/bin/bash
TMPUPPER="$1/$2-ovl/$2-tmpupper"
UPPER="$1/$2-ovl/$2-upper"
LOWER="$1/$2-ovl/$2-lower"

check()
{
	#echo "-----------"
	local dir="$1"

    # 遍历当前目录的内容
    for item in "$dir"/*; do
	    #echo "大循环item=【$item】"
		local upper_dir=$(echo "$dir" | sed 's/tmpupper/upper/1')
		local lower_dir=$(echo "$dir" | sed 's/tmpupper/lower/1')
		#echo "dir=$dir"
		#echo "upper_dir=$upper_dir"
	    file_type=$(LC_ALL=C stat -c %F $item)
	    #echo "type=$file_type"
    	if [ -d "$item" ]; then
        # 如果是目录，则递归调用
            check "$item"
        elif [ "$file_type" = "character special file" ]; then
			dev_major_minor=$(ls -l "$item" | awk '{print $5$6}')
			#echo "dev_major_minor=$dev_major_minor"
			if [ "$dev_major_minor" = "0,0" ]; then
				# 检查/etc-upper中是否存在同名文件或目录
				if [ -e "$upper_dir/$(basename "$item")" ]; then  ##是由etc-upper新增或修改的文件
					#echo "upper 已存在"
					# 检查/etc-lower中是否存在同名文件或目录
					if [ -e "$lower_dir/$(basename "$item")" ]; then    ##etc-lower、/etc目录存在，则证明etc-upper目录下知识对该文件修改的，而不是新增。那么直接将删除标记移动到upper即可
						# 拷贝字符设备到/etc-upper同级目录下
						##deploy is not ++++ ?
						#echo "lower 已存在"
						#echo "----执行 cp -aL $item $upper_dir -----"
						cp -a -rf -P "$item" "$upper_dir/"
					else
						#echo "lower 不存在"
						# /etc-lower中不存在，删除/etc-upper同级目录下的该文件
						#echo "----执行 rm -f $upper_dir/$(basename $item) ----"
						rm -rf "$upper_dir/$(basename "$item")"
 					fi

				fi
			fi
         else        ##非字符设备，那么tmp-upper非删除 即新增或修改，新增无需处理
                        ##tmp-upper与upper相同部分就是修改的文件，那么将tmp-upper的修改同步到upper目录即可
			if [ -e "$upper_dir/$(basename "$item")" ]; then
                #echo "----执行 cp -aL -r $item $upper_dir ------"
                cp -a -rf -P "$item" "$upper_dir/"
			fi
     
        fi
    done

}

check $TMPUPPER
